<template>
    <div @click="showModal">
        <slot></slot>
        <modal v-model="isModalOpen" :footer="false">
            <slot name="form" :events="{ post }" :data="{ loading }"></slot>
        </modal>
    </div>
</template>

<script lang="ts">
    import BaseCrudBtn from '../../common/crud/BaseCrudBtn'
    import Component from 'vue-class-component'
    import PostInterface from '../../../interfaces/common/crud/PostInterface'

    @Component({})
    export default class StoreBtnBtn extends BaseCrudBtn implements PostInterface {
        post(entity) {
            this.loading = true

            this.http.post(
                this.route,
                entity,
                (res) => {
                    this.$emit('success', res)
                    this.loading = false
                    this.alert.success('Success')
                    this.closeModal()
                },
                (err) => {
                    this.$emit('error', err)
                    this.alert.error('Error')
                }
            )
        }
    }
</script>